'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref7) {
  var t = _ref7.types;
  var template = _ref7.template;
  var options = _ref7.options;

  function _ref(_id) {
    if (!Plugin(_id)) {
      throw new TypeError('Function return value violates contract, expected Plugin got ' + (_id === null ? 'null' : (typeof _id === 'undefined' ? 'undefined' : _typeof(_id)) === 'object' && _id.constructor ? _id.constructor.name || '[Unknown Object]' : typeof _id === 'undefined' ? 'undefined' : _typeof(_id)));
    }

    return _id;
  }

  var PRECONDITION_NAME = 'pre';
  var POSTCONDITION_NAME = 'post';
  var INVARIANT_NAME = 'invariant';
  var ASSERT_NAME = 'assert';
  var RETURN_NAME = 'it';
  var OLD_VALUE_NAME = 'old';
  var returnId = t.identifier(RETURN_NAME);

  if (!Identifier(returnId)) {
    throw new TypeError('Value of variable "returnId" violates contract, expected Identifier got ' + (returnId === null ? 'null' : (typeof returnId === 'undefined' ? 'undefined' : _typeof(returnId)) === 'object' && returnId.constructor ? returnId.constructor.name || '[Unknown Object]' : typeof returnId === 'undefined' ? 'undefined' : _typeof(returnId)));
  }

  var guard = template('\n    if (!condition) {\n      throw new Error(message);\n    }\n  ');

  if (!(typeof guard === 'function')) {
    throw new TypeError('Value of variable "guard" violates contract, expected (ids: { [key: string]: Node\n}) => Node got ' + (guard === null ? 'null' : (typeof guard === 'undefined' ? 'undefined' : _typeof(guard)) === 'object' && guard.constructor ? guard.constructor.name || '[Unknown Object]' : typeof guard === 'undefined' ? 'undefined' : _typeof(guard)));
  }

  var guardFn = template('\n    function id (it) {\n      conditions;\n      return it;\n    }\n  ');

  if (!(typeof guardFn === 'function')) {
    throw new TypeError('Value of variable "guardFn" violates contract, expected (ids: { [key: string]: Node\n}) => Node got ' + (guardFn === null ? 'null' : (typeof guardFn === 'undefined' ? 'undefined' : _typeof(guardFn)) === 'object' && guardFn.constructor ? guardFn.constructor.name || '[Unknown Object]' : typeof guardFn === 'undefined' ? 'undefined' : _typeof(guardFn)));
  }

  function assemblePrecondition(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    function _ref2(_id2) {
      if (!(_id2 == null)) {
        throw new TypeError('Function "assemblePrecondition" return value violates contract, expected void got ' + (_id2 === null ? 'null' : (typeof _id2 === 'undefined' ? 'undefined' : _typeof(_id2)) === 'object' && _id2.constructor ? _id2.constructor.name || '[Unknown Object]' : typeof _id2 === 'undefined' ? 'undefined' : _typeof(_id2)));
      }

      return _id2;
    }

    var body = path.get('body');

    if (!NodePath(body)) {
      throw new TypeError('Value of variable "body" violates contract, expected NodePath got ' + (body === null ? 'null' : (typeof body === 'undefined' ? 'undefined' : _typeof(body)) === 'object' && body.constructor ? body.constructor.name || '[Unknown Object]' : typeof body === 'undefined' ? 'undefined' : _typeof(body)));
    }

    var fn = path.getFunctionParent();

    if (!NodePath(fn)) {
      throw new TypeError('Value of variable "fn" violates contract, expected NodePath got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    var name = fn.node.id ? '"' + fn.node.id.name + '" ' : ' ';
    if (body.isExpressionStatement()) {
      var condition = body.get('expression');

      if (!NodePath(condition)) {
        throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
      }

      var message = undefined;

      if (!(message == null || Node(message))) {
        throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
      }

      if (condition.isSequenceExpression()) {
        var expressions = condition.get('expressions');
        condition = expressions[0];

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        message = expressions[1].node;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      } else {
        message = t.stringLiteral('Function ' + name + 'precondition failed: ' + (0, _babelGenerator2.default)(condition.node).code);

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      }
      path.replaceWith(guard({
        condition: condition,
        message: message
      }));
      return;
    }

    body.traverse({
      "VariableDeclaration|Function|AssignmentExpression|UpdateExpression|YieldExpression|ReturnStatement": function VariableDeclarationFunctionAssignmentExpressionUpdateExpressionYieldExpressionReturnStatement(item) {
        if (!NodePath(item)) {
          throw new TypeError('Value of argument "item" violates contract, expected NodePath got ' + (item === null ? 'null' : (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && item.constructor ? item.constructor.name || '[Unknown Object]' : typeof item === 'undefined' ? 'undefined' : _typeof(item)));
        }

        function _VariableDeclaration(_id3) {
          if (!(_id3 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id3 === null ? 'null' : (typeof _id3 === 'undefined' ? 'undefined' : _typeof(_id3)) === 'object' && _id3.constructor ? _id3.constructor.name || '[Unknown Object]' : typeof _id3 === 'undefined' ? 'undefined' : _typeof(_id3)));
          }

          return _id3;
        }

        throw path.buildCodeFrameError('Preconditions cannot have side effects.');
      },
      ExpressionStatement: function ExpressionStatement(statement) {
        if (!NodePath(statement)) {
          throw new TypeError('Value of argument "statement" violates contract, expected NodePath got ' + (statement === null ? 'null' : (typeof statement === 'undefined' ? 'undefined' : _typeof(statement)) === 'object' && statement.constructor ? statement.constructor.name || '[Unknown Object]' : typeof statement === 'undefined' ? 'undefined' : _typeof(statement)));
        }

        function _ExpressionStatement(_id4) {
          if (!(_id4 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id4 === null ? 'null' : (typeof _id4 === 'undefined' ? 'undefined' : _typeof(_id4)) === 'object' && _id4.constructor ? _id4.constructor.name || '[Unknown Object]' : typeof _id4 === 'undefined' ? 'undefined' : _typeof(_id4)));
          }

          return _id4;
        }

        var condition = statement.get('expression');

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        var message = undefined;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }

        if (condition.isSequenceExpression()) {
          var expressions = condition.get('expressions');
          condition = expressions[0];

          if (!NodePath(condition)) {
            throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
          }

          message = expressions[1].node;

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }
        } else {
          message = t.stringLiteral('Function ' + name + 'precondition failed: ' + (0, _babelGenerator2.default)(condition.node).code);

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }
        }
        statement.replaceWith(guard({
          condition: condition,
          message: message
        }));
      }
    });

    if (body.isBlockStatement()) {
      path.replaceWithMultiple(path.get('body').node.body);
    } else {
      path.replaceWith(path.get('body'));
    }
  }

  function assemblePostcondition(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    function _ref3(_id5) {
      if (!Identifier(_id5)) {
        throw new TypeError('Function "assemblePostcondition" return value violates contract, expected Identifier got ' + (_id5 === null ? 'null' : (typeof _id5 === 'undefined' ? 'undefined' : _typeof(_id5)) === 'object' && _id5.constructor ? _id5.constructor.name || '[Unknown Object]' : typeof _id5 === 'undefined' ? 'undefined' : _typeof(_id5)));
      }

      return _id5;
    }

    var body = path.get('body');

    if (!NodePath(body)) {
      throw new TypeError('Value of variable "body" violates contract, expected NodePath got ' + (body === null ? 'null' : (typeof body === 'undefined' ? 'undefined' : _typeof(body)) === 'object' && body.constructor ? body.constructor.name || '[Unknown Object]' : typeof body === 'undefined' ? 'undefined' : _typeof(body)));
    }

    var fn = path.getFunctionParent();

    if (!NodePath(fn)) {
      throw new TypeError('Value of variable "fn" violates contract, expected NodePath got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    var name = fn.node.id ? '"' + fn.node.id.name + '" ' : ' ';
    var conditions = [];

    if (!(Array.isArray(conditions) && conditions.every(function (item) {
      return Node(item);
    }))) {
      throw new TypeError('Value of variable "conditions" violates contract, expected Node[] got ' + (conditions === null ? 'null' : (typeof conditions === 'undefined' ? 'undefined' : _typeof(conditions)) === 'object' && conditions.constructor ? conditions.constructor.name || '[Unknown Object]' : typeof conditions === 'undefined' ? 'undefined' : _typeof(conditions)));
    }

    var captures = [];

    if (!(Array.isArray(captures) && captures.every(function (item) {
      return Node(item);
    }))) {
      throw new TypeError('Value of variable "captures" violates contract, expected Node[] got ' + (captures === null ? 'null' : (typeof captures === 'undefined' ? 'undefined' : _typeof(captures)) === 'object' && captures.constructor ? captures.constructor.name || '[Unknown Object]' : typeof captures === 'undefined' ? 'undefined' : _typeof(captures)));
    }

    if (body.isExpressionStatement()) {
      var condition = body.get('expression');

      if (!NodePath(condition)) {
        throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
      }

      var message = undefined;

      if (!(message == null || Node(message))) {
        throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
      }

      if (condition.isSequenceExpression()) {
        var expressions = condition.get('expressions');
        condition = expressions[0];

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        message = expressions[1].node;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      } else {
        message = t.stringLiteral('Function ' + name + 'postcondition failed: ' + (0, _babelGenerator2.default)(condition.node).code);

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      }
      conditions.push(guard({
        condition: condition,
        message: message
      }));
    } else {
      body.traverse({
        "VariableDeclaration|Function|AssignmentExpression|UpdateExpression|YieldExpression|ReturnStatement": function VariableDeclarationFunctionAssignmentExpressionUpdateExpressionYieldExpressionReturnStatement(item) {
          if (!NodePath(item)) {
            throw new TypeError('Value of argument "item" violates contract, expected NodePath got ' + (item === null ? 'null' : (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && item.constructor ? item.constructor.name || '[Unknown Object]' : typeof item === 'undefined' ? 'undefined' : _typeof(item)));
          }

          function _VariableDeclaration2(_id6) {
            if (!(_id6 == null)) {
              throw new TypeError('Function return value violates contract, expected void got ' + (_id6 === null ? 'null' : (typeof _id6 === 'undefined' ? 'undefined' : _typeof(_id6)) === 'object' && _id6.constructor ? _id6.constructor.name || '[Unknown Object]' : typeof _id6 === 'undefined' ? 'undefined' : _typeof(_id6)));
            }

            return _id6;
          }

          throw path.buildCodeFrameError('Postconditions cannot have side effects.');
        },
        CallExpression: function CallExpression(call) {
          if (!NodePath(call)) {
            throw new TypeError('Value of argument "call" violates contract, expected NodePath got ' + (call === null ? 'null' : (typeof call === 'undefined' ? 'undefined' : _typeof(call)) === 'object' && call.constructor ? call.constructor.name || '[Unknown Object]' : typeof call === 'undefined' ? 'undefined' : _typeof(call)));
          }

          function _CallExpression(_id7) {
            if (!(_id7 == null)) {
              throw new TypeError('Function return value violates contract, expected void got ' + (_id7 === null ? 'null' : (typeof _id7 === 'undefined' ? 'undefined' : _typeof(_id7)) === 'object' && _id7.constructor ? _id7.constructor.name || '[Unknown Object]' : typeof _id7 === 'undefined' ? 'undefined' : _typeof(_id7)));
            }

            return _id7;
          }

          var callee = call.get('callee');

          if (!NodePath(callee)) {
            throw new TypeError('Value of variable "callee" violates contract, expected NodePath got ' + (callee === null ? 'null' : (typeof callee === 'undefined' ? 'undefined' : _typeof(callee)) === 'object' && callee.constructor ? callee.constructor.name || '[Unknown Object]' : typeof callee === 'undefined' ? 'undefined' : _typeof(callee)));
          }

          var args = call.get('arguments');

          if (!(Array.isArray(args) && args.every(function (item) {
            return NodePath(item);
          }))) {
            throw new TypeError('Value of variable "args" violates contract, expected NodePath[] got ' + (args === null ? 'null' : (typeof args === 'undefined' ? 'undefined' : _typeof(args)) === 'object' && args.constructor ? args.constructor.name || '[Unknown Object]' : typeof args === 'undefined' ? 'undefined' : _typeof(args)));
          }

          if (!callee.isIdentifier() || callee.node.name !== OLD_VALUE_NAME || call.scope.hasBinding(OLD_VALUE_NAME) || args.length === 0) {
            return;
          }
          var argument = args[0];

          if (!NodePath(argument)) {
            throw new TypeError('Value of variable "argument" violates contract, expected NodePath got ' + (argument === null ? 'null' : (typeof argument === 'undefined' ? 'undefined' : _typeof(argument)) === 'object' && argument.constructor ? argument.constructor.name || '[Unknown Object]' : typeof argument === 'undefined' ? 'undefined' : _typeof(argument)));
          }

          var id = call.scope.generateUidIdentifierBasedOnNode(argument.node);
          fn.scope.push({ id: id, init: argument.node, kind: 'const' });
          call.replaceWith(id);
        },
        ExpressionStatement: function ExpressionStatement(statement) {
          if (!NodePath(statement)) {
            throw new TypeError('Value of argument "statement" violates contract, expected NodePath got ' + (statement === null ? 'null' : (typeof statement === 'undefined' ? 'undefined' : _typeof(statement)) === 'object' && statement.constructor ? statement.constructor.name || '[Unknown Object]' : typeof statement === 'undefined' ? 'undefined' : _typeof(statement)));
          }

          function _ExpressionStatement2(_id8) {
            if (!(_id8 == null)) {
              throw new TypeError('Function return value violates contract, expected void got ' + (_id8 === null ? 'null' : (typeof _id8 === 'undefined' ? 'undefined' : _typeof(_id8)) === 'object' && _id8.constructor ? _id8.constructor.name || '[Unknown Object]' : typeof _id8 === 'undefined' ? 'undefined' : _typeof(_id8)));
            }

            return _id8;
          }

          var condition = statement.get('expression');

          if (!NodePath(condition)) {
            throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
          }

          var message = undefined;

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }

          if (condition.isSequenceExpression()) {
            var expressions = condition.get('expressions');
            condition = expressions[0];

            if (!NodePath(condition)) {
              throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
            }

            message = expressions[1].node;

            if (!(message == null || Node(message))) {
              throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
            }
          } else {
            message = t.stringLiteral('Function ' + name + 'postcondition failed: ' + (0, _babelGenerator2.default)(condition.node).code);

            if (!(message == null || Node(message))) {
              throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
            }
          }
          statement.replaceWith(guard({
            condition: condition,
            message: message
          }));
        }
      });
      conditions.push.apply(conditions, _toConsumableArray(body.node.body));
    }

    var id = path.scope.generateUidIdentifier((fn.node.id ? fn.node.id.name : 'check') + 'Postcondition');

    path.replaceWith(guardFn({
      id: id,
      conditions: conditions,
      it: returnId
    }));

    return _ref3(id);
  }

  function assembleAssertion(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    function _ref4(_id9) {
      if (!(_id9 == null)) {
        throw new TypeError('Function "assembleAssertion" return value violates contract, expected void got ' + (_id9 === null ? 'null' : (typeof _id9 === 'undefined' ? 'undefined' : _typeof(_id9)) === 'object' && _id9.constructor ? _id9.constructor.name || '[Unknown Object]' : typeof _id9 === 'undefined' ? 'undefined' : _typeof(_id9)));
      }

      return _id9;
    }

    var body = path.get('body');

    if (!NodePath(body)) {
      throw new TypeError('Value of variable "body" violates contract, expected NodePath got ' + (body === null ? 'null' : (typeof body === 'undefined' ? 'undefined' : _typeof(body)) === 'object' && body.constructor ? body.constructor.name || '[Unknown Object]' : typeof body === 'undefined' ? 'undefined' : _typeof(body)));
    }

    var fn = path.getFunctionParent();

    if (!(fn == null || NodePath(fn))) {
      throw new TypeError('Value of variable "fn" violates contract, expected ?NodePath got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    var name = fn && fn.node && fn.node.id ? '"' + fn.node.id.name + '"' : '';
    if (body.isExpressionStatement()) {
      var condition = body.get('expression');

      if (!NodePath(condition)) {
        throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
      }

      var message = undefined;

      if (!(message == null || Node(message))) {
        throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
      }

      if (condition.isSequenceExpression()) {
        var expressions = condition.get('expressions');
        condition = expressions[0];

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        message = expressions[1].node;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      } else if (name) {
        message = t.stringLiteral('Function ' + name + ' assertion failed: ' + (0, _babelGenerator2.default)(condition.node).code);

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      } else {
        message = t.stringLiteral('Assertion failed: ' + (0, _babelGenerator2.default)(condition.node).code);

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      }
      path.replaceWith(guard({
        condition: condition,
        message: message
      }));
      return;
    }

    body.traverse({
      "VariableDeclaration|Function|AssignmentExpression|UpdateExpression|YieldExpression|ReturnStatement": function VariableDeclarationFunctionAssignmentExpressionUpdateExpressionYieldExpressionReturnStatement(item) {
        if (!NodePath(item)) {
          throw new TypeError('Value of argument "item" violates contract, expected NodePath got ' + (item === null ? 'null' : (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && item.constructor ? item.constructor.name || '[Unknown Object]' : typeof item === 'undefined' ? 'undefined' : _typeof(item)));
        }

        function _VariableDeclaration3(_id10) {
          if (!(_id10 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id10 === null ? 'null' : (typeof _id10 === 'undefined' ? 'undefined' : _typeof(_id10)) === 'object' && _id10.constructor ? _id10.constructor.name || '[Unknown Object]' : typeof _id10 === 'undefined' ? 'undefined' : _typeof(_id10)));
          }

          return _id10;
        }

        throw path.buildCodeFrameError('Assertions cannot have side effects.');
      },
      ExpressionStatement: function ExpressionStatement(statement) {
        if (!NodePath(statement)) {
          throw new TypeError('Value of argument "statement" violates contract, expected NodePath got ' + (statement === null ? 'null' : (typeof statement === 'undefined' ? 'undefined' : _typeof(statement)) === 'object' && statement.constructor ? statement.constructor.name || '[Unknown Object]' : typeof statement === 'undefined' ? 'undefined' : _typeof(statement)));
        }

        function _ExpressionStatement3(_id11) {
          if (!(_id11 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id11 === null ? 'null' : (typeof _id11 === 'undefined' ? 'undefined' : _typeof(_id11)) === 'object' && _id11.constructor ? _id11.constructor.name || '[Unknown Object]' : typeof _id11 === 'undefined' ? 'undefined' : _typeof(_id11)));
          }

          return _id11;
        }

        var condition = statement.get('expression');

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        var message = undefined;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }

        if (condition.isSequenceExpression()) {
          var expressions = condition.get('expressions');
          condition = expressions[0];

          if (!NodePath(condition)) {
            throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
          }

          message = expressions[1].node;

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }
        } else if (name) {
          message = t.stringLiteral('Function ' + name + ' assertion failed: ' + (0, _babelGenerator2.default)(condition.node).code);

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }
        } else {
          message = t.stringLiteral('Assertion failed: ' + (0, _babelGenerator2.default)(condition.node).code);

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }
        }
        statement.replaceWith(guard({
          condition: condition,
          message: message
        }));
      }
    });

    if (body.isBlockStatement()) {
      path.replaceWithMultiple(path.get('body').node.body);
    } else {
      path.replaceWith(path.get('body'));
    }
  }

  function assembleInvariant(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    function _ref5(_id12) {
      if (!Identifier(_id12)) {
        throw new TypeError('Function "assembleInvariant" return value violates contract, expected Identifier got ' + (_id12 === null ? 'null' : (typeof _id12 === 'undefined' ? 'undefined' : _typeof(_id12)) === 'object' && _id12.constructor ? _id12.constructor.name || '[Unknown Object]' : typeof _id12 === 'undefined' ? 'undefined' : _typeof(_id12)));
      }

      return _id12;
    }

    var body = path.get('body');

    if (!NodePath(body)) {
      throw new TypeError('Value of variable "body" violates contract, expected NodePath got ' + (body === null ? 'null' : (typeof body === 'undefined' ? 'undefined' : _typeof(body)) === 'object' && body.constructor ? body.constructor.name || '[Unknown Object]' : typeof body === 'undefined' ? 'undefined' : _typeof(body)));
    }

    var fn = path.getFunctionParent();

    if (!NodePath(fn)) {
      throw new TypeError('Value of variable "fn" violates contract, expected NodePath got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    var name = fn.node.id ? '"' + fn.node.id.name + '" ' : ' ';
    var conditions = [];

    if (!(Array.isArray(conditions) && conditions.every(function (item) {
      return Node(item);
    }))) {
      throw new TypeError('Value of variable "conditions" violates contract, expected Node[] got ' + (conditions === null ? 'null' : (typeof conditions === 'undefined' ? 'undefined' : _typeof(conditions)) === 'object' && conditions.constructor ? conditions.constructor.name || '[Unknown Object]' : typeof conditions === 'undefined' ? 'undefined' : _typeof(conditions)));
    }

    if (body.isExpressionStatement()) {
      var condition = body.get('expression');

      if (!NodePath(condition)) {
        throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
      }

      var message = undefined;

      if (!(message == null || Node(message))) {
        throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
      }

      if (condition.isSequenceExpression()) {
        var expressions = condition.get('expressions');
        condition = expressions[0];

        if (!NodePath(condition)) {
          throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
        }

        message = expressions[1].node;

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      } else {
        message = t.stringLiteral('Function ' + name + 'invariant failed: ' + (0, _babelGenerator2.default)(condition.node).code);

        if (!(message == null || Node(message))) {
          throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
        }
      }
      conditions.push(guard({
        condition: condition,
        message: message
      }));
    } else {
      body.traverse({
        "VariableDeclaration|Function|AssignmentExpression|UpdateExpression|YieldExpression|ReturnStatement": function VariableDeclarationFunctionAssignmentExpressionUpdateExpressionYieldExpressionReturnStatement(item) {
          if (!NodePath(item)) {
            throw new TypeError('Value of argument "item" violates contract, expected NodePath got ' + (item === null ? 'null' : (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && item.constructor ? item.constructor.name || '[Unknown Object]' : typeof item === 'undefined' ? 'undefined' : _typeof(item)));
          }

          function _VariableDeclaration4(_id13) {
            if (!(_id13 == null)) {
              throw new TypeError('Function return value violates contract, expected void got ' + (_id13 === null ? 'null' : (typeof _id13 === 'undefined' ? 'undefined' : _typeof(_id13)) === 'object' && _id13.constructor ? _id13.constructor.name || '[Unknown Object]' : typeof _id13 === 'undefined' ? 'undefined' : _typeof(_id13)));
            }

            return _id13;
          }

          throw path.buildCodeFrameError('Invariants cannot have side effects.');
        },
        ExpressionStatement: function ExpressionStatement(statement) {
          if (!NodePath(statement)) {
            throw new TypeError('Value of argument "statement" violates contract, expected NodePath got ' + (statement === null ? 'null' : (typeof statement === 'undefined' ? 'undefined' : _typeof(statement)) === 'object' && statement.constructor ? statement.constructor.name || '[Unknown Object]' : typeof statement === 'undefined' ? 'undefined' : _typeof(statement)));
          }

          function _ExpressionStatement4(_id14) {
            if (!(_id14 == null)) {
              throw new TypeError('Function return value violates contract, expected void got ' + (_id14 === null ? 'null' : (typeof _id14 === 'undefined' ? 'undefined' : _typeof(_id14)) === 'object' && _id14.constructor ? _id14.constructor.name || '[Unknown Object]' : typeof _id14 === 'undefined' ? 'undefined' : _typeof(_id14)));
            }

            return _id14;
          }

          var condition = statement.get('expression');

          if (!NodePath(condition)) {
            throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
          }

          var message = undefined;

          if (!(message == null || Node(message))) {
            throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
          }

          if (condition.isSequenceExpression()) {
            var expressions = condition.get('expressions');
            condition = expressions[0];

            if (!NodePath(condition)) {
              throw new TypeError('Value of variable "condition" violates contract, expected NodePath got ' + (condition === null ? 'null' : (typeof condition === 'undefined' ? 'undefined' : _typeof(condition)) === 'object' && condition.constructor ? condition.constructor.name || '[Unknown Object]' : typeof condition === 'undefined' ? 'undefined' : _typeof(condition)));
            }

            message = expressions[1].node;

            if (!(message == null || Node(message))) {
              throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
            }
          } else {
            message = t.stringLiteral('Function ' + name + 'invariant failed: ' + (0, _babelGenerator2.default)(condition.node).code);

            if (!(message == null || Node(message))) {
              throw new TypeError('Value of variable "message" violates contract, expected ?Node got ' + (message === null ? 'null' : (typeof message === 'undefined' ? 'undefined' : _typeof(message)) === 'object' && message.constructor ? message.constructor.name || '[Unknown Object]' : typeof message === 'undefined' ? 'undefined' : _typeof(message)));
            }
          }
          statement.replaceWith(guard({
            condition: condition,
            message: message
          }));
        }
      });
      conditions.push.apply(conditions, _toConsumableArray(body.node.body));
    }

    var id = path.scope.generateUidIdentifier((fn.node.id ? fn.node.id.name : 'check') + 'Invariant');

    path.replaceWith(guardFn({
      id: id,
      conditions: conditions,
      it: returnId
    }));

    return _ref5(id);
  }

  function expression(input) {
    if (!(typeof input === 'string')) {
      throw new TypeError('Value of argument "input" violates contract, expected string got ' + (input === null ? 'null' : (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && input.constructor ? input.constructor.name || '[Unknown Object]' : typeof input === 'undefined' ? 'undefined' : _typeof(input)));
    }

    function _ref6(_id15) {
      if (!(typeof _id15 === 'function')) {
        throw new TypeError('Function "expression" return value violates contract, expected Function got ' + (_id15 === null ? 'null' : (typeof _id15 === 'undefined' ? 'undefined' : _typeof(_id15)) === 'object' && _id15.constructor ? _id15.constructor.name || '[Unknown Object]' : typeof _id15 === 'undefined' ? 'undefined' : _typeof(_id15)));
      }

      return _id15;
    }

    var fn = template(input);

    if (!(typeof fn === 'function')) {
      throw new TypeError('Value of variable "fn" violates contract, expected Function got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    return _ref6(function () {
      var node = fn.apply(undefined, arguments);

      if (!Node(node)) {
        throw new TypeError('Value of variable "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
      }

      return getExpression(node);
    });
  }

  return _ref({
    visitor: {
      Function: function Function(fn, _ref8) {
        var opts = _ref8.opts;

        if (!NodePath(fn)) {
          throw new TypeError('Value of argument "fn" violates contract, expected NodePath got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
        }

        function _Function(_id16) {
          if (!(_id16 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id16 === null ? 'null' : (typeof _id16 === 'undefined' ? 'undefined' : _typeof(_id16)) === 'object' && _id16.constructor ? _id16.constructor.name || '[Unknown Object]' : typeof _id16 === 'undefined' ? 'undefined' : _typeof(_id16)));
          }

          return _id16;
        }

        if (fn.isArrowFunctionExpression() && !fn.get('body').isBlockStatement()) {
          // Naked arrow functions cannot contain contracts.
          return;
        }
        fn.traverse({
          Function: function Function(path) {
            if (!NodePath(path)) {
              throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
            }

            function _Function2(_id17) {
              if (!(_id17 == null)) {
                throw new TypeError('Function return value violates contract, expected void got ' + (_id17 === null ? 'null' : (typeof _id17 === 'undefined' ? 'undefined' : _typeof(_id17)) === 'object' && _id17.constructor ? _id17.constructor.name || '[Unknown Object]' : typeof _id17 === 'undefined' ? 'undefined' : _typeof(_id17)));
              }

              return _id17;
            }

            // This will be handled by the outer visitor, so skip it.
            path.skip();
          },
          LabeledStatement: function LabeledStatement(path) {
            if (!NodePath(path)) {
              throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
            }

            function _LabeledStatement(_id18) {
              if (!(_id18 == null)) {
                throw new TypeError('Function return value violates contract, expected void got ' + (_id18 === null ? 'null' : (typeof _id18 === 'undefined' ? 'undefined' : _typeof(_id18)) === 'object' && _id18.constructor ? _id18.constructor.name || '[Unknown Object]' : typeof _id18 === 'undefined' ? 'undefined' : _typeof(_id18)));
              }

              return _id18;
            }

            var label = path.get('label');

            if (!NodePath(label)) {
              throw new TypeError('Value of variable "label" violates contract, expected NodePath got ' + (label === null ? 'null' : (typeof label === 'undefined' ? 'undefined' : _typeof(label)) === 'object' && label.constructor ? label.constructor.name || '[Unknown Object]' : typeof label === 'undefined' ? 'undefined' : _typeof(label)));
            }

            if (opts.strip || opts.env && opts.env[process.env.NODE_ENV] && opts.env[process.env.NODE_ENV].strip) {
              if (label.node.name === PRECONDITION_NAME || label.node.name === POSTCONDITION_NAME || label.node.name === INVARIANT_NAME || label.node.name === ASSERT_NAME) {
                path.remove();
              }
              return;
            }

            var id = undefined;

            if (!(id == null || Identifier(id))) {
              throw new TypeError('Value of variable "id" violates contract, expected ?Identifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
            }

            var children = undefined;

            if (!(children == null || Array.isArray(children) && children.every(function (item) {
              return NodePath(item);
            }))) {
              throw new TypeError('Value of variable "children" violates contract, expected ?NodePath[] got ' + (children === null ? 'null' : (typeof children === 'undefined' ? 'undefined' : _typeof(children)) === 'object' && children.constructor ? children.constructor.name || '[Unknown Object]' : typeof children === 'undefined' ? 'undefined' : _typeof(children)));
            }

            var parent = fn;

            if (!NodePath(parent)) {
              throw new TypeError('Value of variable "parent" violates contract, expected NodePath got ' + (parent === null ? 'null' : (typeof parent === 'undefined' ? 'undefined' : _typeof(parent)) === 'object' && parent.constructor ? parent.constructor.name || '[Unknown Object]' : typeof parent === 'undefined' ? 'undefined' : _typeof(parent)));
            }

            if (label.node.name === PRECONDITION_NAME) {
              assemblePrecondition(path);
              return;
            } else if (label.node.name === POSTCONDITION_NAME) {
              id = assemblePostcondition(path);
              children = fn.get('body').get('body');

              if (!(children == null || Array.isArray(children) && children.every(function (item) {
                return NodePath(item);
              }))) {
                throw new TypeError('Value of variable "children" violates contract, expected ?NodePath[] got ' + (children === null ? 'null' : (typeof children === 'undefined' ? 'undefined' : _typeof(children)) === 'object' && children.constructor ? children.constructor.name || '[Unknown Object]' : typeof children === 'undefined' ? 'undefined' : _typeof(children)));
              }
            } else if (label.node.name === ASSERT_NAME) {
              assembleAssertion(path);
              return;
            } else if (label.node.name === INVARIANT_NAME) {
              id = assembleInvariant(path);
              parent = path.findParent(t.isBlockStatement);

              if (!NodePath(parent)) {
                throw new TypeError('Value of variable "parent" violates contract, expected NodePath got ' + (parent === null ? 'null' : (typeof parent === 'undefined' ? 'undefined' : _typeof(parent)) === 'object' && parent.constructor ? parent.constructor.name || '[Unknown Object]' : typeof parent === 'undefined' ? 'undefined' : _typeof(parent)));
              }

              children = parent.get('body');

              if (!(children == null || Array.isArray(children) && children.every(function (item) {
                return NodePath(item);
              }))) {
                throw new TypeError('Value of variable "children" violates contract, expected ?NodePath[] got ' + (children === null ? 'null' : (typeof children === 'undefined' ? 'undefined' : _typeof(children)) === 'object' && children.constructor ? children.constructor.name || '[Unknown Object]' : typeof children === 'undefined' ? 'undefined' : _typeof(children)));
              }

              var first = children[0];

              if (!NodePath(first)) {
                throw new TypeError('Value of variable "first" violates contract, expected NodePath got ' + (first === null ? 'null' : (typeof first === 'undefined' ? 'undefined' : _typeof(first)) === 'object' && first.constructor ? first.constructor.name || '[Unknown Object]' : typeof first === 'undefined' ? 'undefined' : _typeof(first)));
              }

              first.insertBefore(t.expressionStatement(t.callExpression(id, [])));
            }
            parent.traverse({
              Function: function Function(path) {
                if (!NodePath(path)) {
                  throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
                }

                function _Function3(_id19) {
                  if (!(_id19 == null)) {
                    throw new TypeError('Function return value violates contract, expected void got ' + (_id19 === null ? 'null' : (typeof _id19 === 'undefined' ? 'undefined' : _typeof(_id19)) === 'object' && _id19.constructor ? _id19.constructor.name || '[Unknown Object]' : typeof _id19 === 'undefined' ? 'undefined' : _typeof(_id19)));
                  }

                  return _id19;
                }

                // This will be handled by the outer visitor, so skip it.
                path.skip();
              },
              ReturnStatement: function ReturnStatement(statement) {
                if (!NodePath(statement)) {
                  throw new TypeError('Value of argument "statement" violates contract, expected NodePath got ' + (statement === null ? 'null' : (typeof statement === 'undefined' ? 'undefined' : _typeof(statement)) === 'object' && statement.constructor ? statement.constructor.name || '[Unknown Object]' : typeof statement === 'undefined' ? 'undefined' : _typeof(statement)));
                }

                function _ReturnStatement(_id20) {
                  if (!(_id20 == null)) {
                    throw new TypeError('Function return value violates contract, expected void got ' + (_id20 === null ? 'null' : (typeof _id20 === 'undefined' ? 'undefined' : _typeof(_id20)) === 'object' && _id20.constructor ? _id20.constructor.name || '[Unknown Object]' : typeof _id20 === 'undefined' ? 'undefined' : _typeof(_id20)));
                  }

                  return _id20;
                }

                statement.get('argument').replaceWith(t.callExpression(id, [statement.node.argument]));
              }
            });
            var last = children[children.length - 1];

            if (!NodePath(last)) {
              throw new TypeError('Value of variable "last" violates contract, expected NodePath got ' + (last === null ? 'null' : (typeof last === 'undefined' ? 'undefined' : _typeof(last)) === 'object' && last.constructor ? last.constructor.name || '[Unknown Object]' : typeof last === 'undefined' ? 'undefined' : _typeof(last)));
            }

            if (!last.isReturnStatement()) {
              last.insertAfter(t.expressionStatement(t.callExpression(id, [])));
            }
          }
        });
      },
      LabeledStatement: function LabeledStatement(path, _ref9) {
        var opts = _ref9.opts;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        function _LabeledStatement2(_id21) {
          if (!(_id21 == null)) {
            throw new TypeError('Function return value violates contract, expected void got ' + (_id21 === null ? 'null' : (typeof _id21 === 'undefined' ? 'undefined' : _typeof(_id21)) === 'object' && _id21.constructor ? _id21.constructor.name || '[Unknown Object]' : typeof _id21 === 'undefined' ? 'undefined' : _typeof(_id21)));
          }

          return _id21;
        }

        var label = path.get('label');

        if (!NodePath(label)) {
          throw new TypeError('Value of variable "label" violates contract, expected NodePath got ' + (label === null ? 'null' : (typeof label === 'undefined' ? 'undefined' : _typeof(label)) === 'object' && label.constructor ? label.constructor.name || '[Unknown Object]' : typeof label === 'undefined' ? 'undefined' : _typeof(label)));
        }

        if (label.node.name === ASSERT_NAME) {
          if (opts.strip || opts.env && opts.env[process.env.NODE_ENV] && opts.env[process.env.NODE_ENV].strip) {
            path.remove();
          } else {
            assembleAssertion(path);
          }
          return;
        }
      }
    }
  });
};

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var Plugin = function Plugin(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && Visitors(input.visitor);
};

var PluginParams = function PluginParams(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && input.types instanceof Object && typeof input.template === 'function';
};

var Visitors = function Visitors(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object';
};

var Visitor = function Visitor(input) {
  return typeof input === 'function';
};

var Node = function Node(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && (input.node === undefined || input.node == null);
};

var Literal = function Literal(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && (input.type === 'StringLiteral' || input.type === 'BooleanLiteral' || input.type === 'NumericLiteral' || input.type === 'NullLiteral' || input.type === 'RegExpLiteral');
};

var Identifier = function Identifier(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && typeof input.name === 'string';
};

var Scope = function Scope(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object';
};

var NodePath = function NodePath(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && Node(input.node) && Scope(input.scope);
};

/**
 * # Design By Contract Transformer
 */